"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var equality_comparer_1 = require("../equality-comparer");
var grouping_1 = require("../grouping");
var enumerable_container_1 = require("./enumerable-container");
var utils = require("../utils");
var assistance = require("./assistance");
function groupBy(source, keySelector, elementSelector, comparer) {
    utils.throws.ThrowIfNull('source', source);
    utils.throws.ThrowIfNull('keySelector', keySelector);
    var _elementSelector = elementSelector || (function (x) { return x; });
    comparer = comparer || equality_comparer_1.EqualityComparer.Default();
    return new enumerable_container_1.EnumerableContainer(assistance
        .group(source, keySelector, _elementSelector, function (x, y) { return comparer.Equals(x, y); })
        .map(function (g) { return new grouping_1.Grouping(g.Key, new enumerable_container_1.EnumerableContainer(g.List)); }));
}
exports.groupBy = groupBy;
//# sourceMappingURL=group-by.js.map