"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var utils_1 = require("../utils");
var enumerable_container_1 = require("./enumerable-container");
var equality_comparer_1 = require("../equality-comparer");
var assistance = require("./assistance");
function union(first, second, comparer) {
    utils_1.throws.ThrowIfNull('first', first);
    utils_1.throws.ThrowIfNull('second', second);
    comparer = comparer || equality_comparer_1.EqualityComparer.Default();
    return new enumerable_container_1.EnumerableContainer(assistance.distinct(assistance.concat(first, second), function (x, y) {
        return comparer.Equals(x, y);
    }));
}
exports.union = union;
//# sourceMappingURL=union.js.map